.686
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib

.data
align 16
  actarr db   1,  3,  2,  3,  16,  6,  9, 48,  14,  8, 42, 27,  19, 15,  7, 40

  maxarr db   5,  7, 11, 13,  17, 19, 23, 53,  29, 31, 59, 37,  41, 43, 47, 61

  zeroes dd 0         ;  esi used instead for speed
  plus24 db 2,2,2,2   ;  edi used instead
  anycnt dd 0         ;  6052595 for 10M iterations
  allcnt dd 0         ;  8805234 for 10M iterations

  times  dd 10000000  ;  ebx used instead
  szCap  db "Mod",0
  P      dd 0
  PID    dd 0

  CrTm   dd 0, 0
  ExTm   dd 0, 0
  KnTm   dd 0, 0   ; kernel time
  UsTm   dd 0, 0   ; user   time

  szFmt  db "%lu",13,10,"%lu",13,10,"%lu",13,10,"%lu",13,10,0
  szMsg  db 100 dup (0)


.code
start:
   mov edi, dword ptr plus24     ; use edi for plus24

alliters:
   mov eax, dword ptr actarr+0   ; get now for dword0
   xor esi, esi                  ; use esi for zeroes
   mov edx, dword ptr maxarr+0   ; get max for dword0
   xor ecx, ecx                  ; use ecx for index into the arrays

manybites:
   add eax, edi  ; add eax, plus24
spot:   
   cmp  al, dl   ;  a < m    4 < 5
   jc  @F        ; al < dl   skip sub 5, == 0
   sub  al, dl   ; do sub, set zero flag if result is 0
   jnz @F        ; if not a 0  skip inc zeroes
   inc esi       ; inc zeroes
@@:
   cmp  ah, dh   ;  a < m    4 < 5
   jc  @F        ; al < dl
   sub  ah, dh
   jnz @F
   inc esi       ; inc zeroes
@@:
   ror eax, 16   ; swap the higher two bytes with the lower
   ror edx, 16   ;

   cmp  al, dl   ;  a < m    4 < 5
   jc  @F        ; al < dl
   sub  al, dl
   jnz @F
   inc esi       ; inc zeroes
@@:
   cmp  ah, dh   ;  a < m    4 < 5
   jc  @F        ; al < dl
   sub  ah, dh
   jnz @F
   inc esi       ; inc zeroes
@@:
   ror eax, 16   ; put dword back in correct order

   mov dword ptr [actarr+ecx*4], eax    ; save it/update memory
   inc ecx
   cmp ecx, 4    ; 4 == 4 dwords,16 bytes  0..3 when 4 done
   jz  @F
   mov eax, dword ptr [actarr+ecx*4]    ; get next actarr dword
   mov edx, dword ptr [maxarr+ecx*4]    ; get next maxarr dword
   jmp manybites
@@:
   cmp esi, 0      ; cmp zeroes, 0
   jz  @F
   inc anycnt      ; inc anycnt
   add allcnt, esi ; add allcnt, zeroes
@@:
   xor edi, 06060606h   ; xor dword ptr plus24, 06060606h  switch 2 to 4 OR 4 to 2
   dec times
   jnz alliters

   invoke GetCurrentProcess
   mov P, eax

   invoke GetProcessTimes, P, addr CrTm, addr ExTm, addr KnTm, addr UsTm

   invoke wsprintf, addr szMsg, addr szFmt, anycnt, allcnt, KnTm+0, UsTm+0
   invoke MessageBox, NULL, addr szMsg, addr szCap, MB_OK
   invoke ExitProcess, NULL
end start

 ; Comparison code in Delphi used to verify
 ; the counts in assembly versions.
 ;
 ;   anycnt := 0;
 ;   allcnt := 0;
 ;   plus24 := 2;
 ;   for i := 1 to 10000000 do begin
 ;     k := 0;  // zeroes
 ;     for j := 0 to 15 do begin
 ;       actarr[j] := actarr[j] + plus24;
 ;       if actarr[j] >= maxarr[j] then begin
 ;          actarr[j] := actarr[j] - maxarr[j];
 ;          if actarr[j] = 0 then
 ;             k := k + 1;
 ;       end;
 ;     end;
 ;     if k > 0 then begin
 ;        anycnt := anycnt + 1;
 ;        allcnt := allcnt + k;
 ;     end;
 ;     plus24 := plus24 xor 6;
 ;   end;
 ;   writeln(anycnt:8,' anycnt');
 ;   writeln(allcnt:8,' allcnt');